<?php

/* -------------------------------------------------------
 *
 *   LiveStreet (v1.x)
 *   Plugin Pre-moderation topics (v.0.1)
 *   Copyright В© 2011 Bishovec Nikolay
 *
 * --------------------------------------------------------
 *
 *   Plugin Page: http://netlanc.net
 *   Contact e-mail: netlanc@yandex.ru
 *
  ---------------------------------------------------------
 */

class PluginPmt_ActionPmt extends ActionPlugin
{

    protected $sMenuHeadItemSelect = 'blog';
    protected $sMenuItemSelect = 'draft';
    protected $oUserCurrent = null;
    protected $aUsersAllow = null;

    public function Init()
    {
        $this->oUserCurrent = $this->User_GetUserCurrent();
        $this->aUsersAllow = Config::Get('plugin.pmt.users_allow');
        if (!$this->oUserCurrent or (!$this->oUserCurrent->isAdministrator() and !in_array($this->oUserCurrent->getLogin(), $this->aUsersAllow))) {
            return parent::EventNotFound();
        }
        $this->SetDefaultEvent('index');
    }

    protected function RegisterEvent()
    {
        $this->AddEvent('index', 'EventShowTopics');
        $this->AddEventPreg('/^(page(\d+))?$/i', 'EventShowTopics');
        $this->AddEventPreg('/^(\d+)$/i','/^$/i',array('EventShowTopic','topic'));
    }
    protected function EventShowTopic() {
        /**
         * Проверяем есть ли такой топик
         */
        if (!($oTopic=$this->Topic_GetTopicById($this->sCurrentEvent))) {
            return parent::EventNotFound();
        }

        /**
         * Обрабатываем добавление коммента
         */

        /**
         * Достаём комменты к топику
         */
        if (!Config::Get('module.comment.nested_page_reverse') and Config::Get('module.comment.use_nested') and Config::Get('module.comment.nested_per_page')) {
            $iPageDef=ceil($this->Comment_GetCountCommentsRootByTargetId($oTopic->getId(),'topic')/Config::Get('module.comment.nested_per_page'));
        } else {
            $iPageDef=1;
        }
        $iPage=getRequest('cmtpage',0) ? (int)getRequest('cmtpage',0) : $iPageDef;
        $aReturn=$this->Comment_GetCommentsByTargetId($oTopic->getId(),'topic',$iPage,Config::Get('module.comment.nested_per_page'));
        $iMaxIdComment=$aReturn['iMaxIdComment'];
        $aComments=$aReturn['comments'];
        /**
         * Если используется постраничность для комментариев - формируем ее
         */
        if (Config::Get('module.comment.use_nested') and Config::Get('module.comment.nested_per_page')) {
            $aPaging=$this->Viewer_MakePaging($aReturn['count'],$iPage,Config::Get('module.comment.nested_per_page'),Config::Get('pagination.pages.count'),'');
            if (!Config::Get('module.comment.nested_page_reverse') and $aPaging) {
                // переворачиваем страницы в обратном порядке
                $aPaging['aPagesLeft']=array_reverse($aPaging['aPagesLeft']);
                $aPaging['aPagesRight']=array_reverse($aPaging['aPagesRight']);
            }
            $this->Viewer_Assign('aPagingCmt',$aPaging);
        }

        /**
         * Выставляем SEO данные
         */
        $sTextSeo=strip_tags($oTopic->getText());
        $this->Viewer_SetHtmlDescription(func_text_words($sTextSeo, Config::Get('seo.description_words_count')));
        $this->Viewer_SetHtmlKeywords($oTopic->getTags());
        /**
         * Вызов хуков
         */
        $this->Hook_Run('topic_show',array("oTopic"=>$oTopic));
        /**
         * Загружаем переменные в шаблон
         */
        $this->Viewer_Assign('oTopic',$oTopic);
        $this->Viewer_Assign('aComments',$aComments);
        $this->Viewer_Assign('iMaxIdComment',$iMaxIdComment);
        /**
         * Устанавливаем title страницы
         */
        $this->Viewer_AddHtmlTitle($oTopic->getBlog()->getTitle());
        $this->Viewer_AddHtmlTitle($oTopic->getTitle());
        $this->Viewer_SetHtmlRssAlternate(Router::GetPath('rss').'comments/'.$oTopic->getId().'/',$oTopic->getTitle());
        /**
         * Устанавливаем шаблон вывода
         */
        $this->SetTemplateAction('topic');
    }
    /**
     * Выводит список топиков
     *
     */
    protected function EventShowTopics()
    {
        /**
         * Меню
         */
        $this->sMenuSubItemSelect = 'draft';
        /**
         * Передан ли номер страницы
         */
        $iPage = $this->GetParamEventMatch(0, 1) ? $this->GetParamEventMatch(0, 1) : 1;
        /**
         * Получаем список топиков
         */
        $aResult = $this->Topic_GetTopicsModeration($iPage, Config::Get('module.topic.per_page'));
        $aTopics = $aResult['collection'];
        /**
         * Формируем постраничность
         */
        $aPaging = $this->Viewer_MakePaging($aResult['count'], $iPage, Config::Get('module.topic.per_page'), 4, Router::GetPath('draft'));
        /**
         * Загружаем переменные в шаблон
         */
        $this->Viewer_Assign('aPaging', $aPaging);
        $this->Viewer_Assign('aTopics', $aTopics);
    }

    /**
     * При завершении экшена загружаем необходимые переменные
     *
     */
    public function EventShutdown()
    {
        $this->Viewer_Assign('sMenuHeadItemSelect', $this->sMenuHeadItemSelect);
        $this->Viewer_Assign('sMenuItemSelect', $this->sMenuItemSelect);
        $this->Viewer_Assign('iCountTopicModeration', $this->Topic_GetCountTopicModeration());
    }

}

?>
