<?php

/* -------------------------------------------------------
 *
 *   LiveStreet (v1.x)
 *   Plugin Pre-moderation topics (v.0.1)
 *   Copyright В© 2011 Bishovec Nikolay
 *
 * --------------------------------------------------------
 *
 *   Plugin Page: http://netlanc.net
 *   Contact e-mail: netlanc@yandex.ru
 *
  ---------------------------------------------------------
 */

class PluginPmt_ModuleACL extends PluginPmt_Inherit_ModuleACL
{

    public function Init()
    {
        parent::Init();
    }

    /**
     * Проверяет можно или нет пользователю удалять данный топик
     *
     * @param object $oTopic
     * @param object $oUser
     */
    public function IsAllowDeleteTopic($oTopic, $oUser)
    {
        $bReturn = parent::IsAllowDeleteTopic($oTopic, $oUser);

        if (!$bReturn) {
            $aUsersAllow = Config::Get('plugin.pmt.users_allow');
            if (!in_array($oUser->getLogin(), $aUsersAllow)) {
                return false;
            }
        }
        return true;
    }

    /**
     * Проверяет можно или нет пользователю редактировать данный топик
     *
     * @param  object $oTopic
     * @param  object $oUser
     * @return bool
     */
    public function IsAllowEditTopic($oTopic, $oUser)
    {

        $bReturn = parent::IsAllowEditTopic($oTopic, $oUser);

        if (!$bReturn) {
            $aUsersAllow = Config::Get('plugin.pmt.users_allow');
            if (!in_array($oUser->getLogin(), $aUsersAllow)) {
                return false;
            }
        }
        return true;
    }

    /**
     * Проверяет можно или нет юзеру постить в данный блог
     *
     * @param ModuleBlog_EntityBlog $oBlog    Блог
     * @param ModuleUser_EntityUser $oUser    Пользователь
     */
    public function IsAllowBlog($oBlog, $oUser)
    {
        $bReturn = parent::IsAllowBlog($oBlog, $oUser);

        if (!$bReturn) {
            $aUsersAllow = Config::Get('plugin.pmt.users_allow');
            if (!in_array($oUser->getLogin(), $aUsersAllow)) {
                return false;
            }
        }
        return true;
    }
}

?>
